#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Orange
#property indicator_color2 White
#property indicator_width1 2
#property indicator_color3  CLR_NONE
#property indicator_width2  2
#property indicator_width3  2

//---- input parameters
extern int    LRLPeriod         = 18;
extern bool   ShowLines         = true;
extern string LinesIdentifier   = "regressionLines1";
extern color  LinesColorForUp   = LimeGreen;
extern color  LinesColorForDown = Red;
extern int    LinesStyle        = STYLE_DOT;

//---- buffers
double LRLBuffer[];
double result[];
double ma[];
double trend[];


int n=0;
double sumx=0, sumy=0, sumxy=0, sumx2=0, sumy2=0;
double m=0, yint=0, r=0;
//+------------------------------------------------------------------+
//|                    INITIALIZATION FUNCTION                       |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0,result);
   SetIndexBuffer(1,ma);
   SetIndexBuffer(2,LRLBuffer);
   SetIndexBuffer(3,trend);
   IndicatorDigits(Digits);
   if(LRLPeriod < 2) LRLPeriod = 2;
   IndicatorShortName("Linear Regression deviation average ("+LRLPeriod+")");
   SetIndexDrawBegin(0,LRLPeriod+2);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                   DEINITIALIZATION FUNCTION                      |
//+------------------------------------------------------------------+
int deinit()
  {
    int lookForLength = StringLen(LinesIdentifier);
   for (int shift=ObjectsTotal(); shift>=0; shift--) {
      string name = ObjectName(shift);
      if (StringSubstr(name,0,lookForLength)==LinesIdentifier) ObjectDelete(name);
   }
   return(0);
   
   return(0);
  }
//+------------------------------------------------------------------+
//|                      ITERATION FUNCTION                          |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int shift=limit-1; shift>=0; shift--)
      {
         sumx = 0;
         sumy = 0;
         sumxy = 0;
         sumx2 = 0;
         sumy2 = 0;
         for(n = 0; n <= LRLPeriod-1; n++)
             { 
               sumx = sumx + n;
               sumy = sumy + Close[shift + n];
               sumxy = sumxy + n * Close[shift + n];
               sumx2 = sumx2 + n * n;
               sumy2 = sumy2 + Close[shift + n] * Close[shift + n]; 
             }                      
         if(LRLPeriod*sumx2-sumx*sumx==0)
               {m=(LRLPeriod*sumxy-sumx*sumy)/(0.00000001);}
         else  {m=(LRLPeriod*sumxy-sumx*sumy)/(LRLPeriod*sumx2-sumx*sumx);} 
         
         yint=(sumy+m*sumx)/LRLPeriod;
         
         if(MathSqrt((LRLPeriod*sumx2-sumx*sumx)*(LRLPeriod*sumy2-sumy*sumy))==0)
               {r=(LRLPeriod*sumxy-sumx*sumy)/(0.00000001);}
         else  {r=(LRLPeriod*sumxy-sumx*sumy)/MathSqrt((LRLPeriod*sumx2-sumx*sumx)*(LRLPeriod*sumy2-sumy*sumy));}
         
         LRLBuffer[shift]=yint-m*LRLPeriod;
         
         double sum=0;
         for(n = 0; n <= LRLPeriod-1; n++)
         {
            double temp  = yint - m*(LRLPeriod- n);
                    sum += temp - (Close[n + shift]);
         }
         result[shift] = 10000.0 * (sum / LRLPeriod);
      }         
      for(shift=limit-1; shift>=0; shift--)
      {
         ma[shift] = iMAOnArray(result,0,LRLPeriod*6,0,MODE_SMA,shift);
         
         trend[shift] = trend[shift+1];
   
            if (result[shift] > ma[shift]) {
                    trend[shift] = 1;
            }
                
            if (result[shift] < ma[shift]) {         
                    trend[shift] = -1;
            }
                
            if (ShowLines)
                     {
                       deleteLine(shift);
                          if (trend[shift]!=trend[shift+1])
                          if (trend[shift]==1)
                                drawLine(shift,LinesColorForUp);
                          else  drawLine(shift,LinesColorForDown);
                     }                  
      }
//      Comment("Trend : ",trend[1],"\n Result : ",result[shift],"\n MA : ",ma[shift2]);
   //for( shift=limit-1; shift>=0; shift--) ma[shift] = iMAOnArray(result,0,LRLPeriod*6,0,MODE_SMA,shift);
   
   return(0);
  }
//+------------------------------------------------------------------+

void deleteLine(int shift)
{
   ObjectDelete(LinesIdentifier+":"+Time[shift]);
}

void drawLine(int shift, color theColor)
{
   string name = LinesIdentifier+":"+Time[shift];
   if (ObjectFind(name)<0)
       ObjectCreate(name,OBJ_VLINE,0,Time[shift],0);
       ObjectSet(name,OBJPROP_COLOR,theColor);
       ObjectSet(name,OBJPROP_BACK,true);
       ObjectSet(name,OBJPROP_STYLE,LinesStyle);
}